/* Generated by Together */


/**
 * @invariants kontostand>-dispoLimit and dispoLimit>0
 */
public class Konto {
    private int maxKontoStand=10000;
    private int kontostand;
    private int dispoLimit;

	public Konto(int initBetrag, int dispo, int maxKontoStand) {
        if (initBetrag<-dispo || dispo<0 || initBetrag>maxKontoStand
            || maxKontoStand<0) {
			throw new IllegalArgumentException();
        }
		this.kontoNr=KontoNummer.generate();
        this.kontostand=initBetrag;
        this.maxKontoStand=maxKontoStand;
        this.dispoLimit=dispo;
    }

    /**hebt den angegebenen positiven Betrag vom Konto ab, wenn dadurch das
     * dispoLimit nicht berschritten wird. Gibt genau dann true zurck, wenn
     * das Abheben erfolgreich war.
     * @preconditions betrag>0
     */
    public boolean abheben(int betrag) {
		if (kontostand-betrag < -dispoLimit) {
			return false;
        } else {
            abbuchen(betrag);
			return true;
        }
    }
	/**
	* subtrahiert den angegebenen Betrag von kontostand. Ist danach das
    * dispoLimit berschritten, wird eine Exception geworfen.
	*/
	private void abbuchen(int betrag) {
		kontostand=kontostand-betrag;
        if (-kontostand>dispoLimit) {
		throw new IllegalStateException();
        }
    }

	public int getKontoStand() {
		return kontostand;
    }

    public int getDispoLimit() {
		return dispoLimit;
    }

    /**
     * @supplierCardinality 1
     * @supplierRole kto
     */
    public KontoNummer kontoNr;

    private int eingabe(){
       String s="";
       try{
            System.out.println("Wieviel wollen Sie abheben? ");
			java.io.BufferedInputStream in=new java.io.BufferedInputStream(System.in);
            int i;
            while ((i=in.read())!=10){
                s=s+(new Character((char)i));
            }
        } catch (Exception e){
            System.err.println("Exception during input occurred!");
            System.exit(1);
        }
     	return (new Integer(s)).intValue();
    }

    public static void main(String[] args){
        int eingabe=0;
        Konto konto=new Konto(-1000, 10000, 100000);
        konto.kontostand=-1000;
        System.out.println("Kontostand vor Abheben: "+konto.kontostand);
        eingabe=konto.eingabe();
		konto.abheben(eingabe);
        System.out.println("Jetzt werden "+eingabe+" Euro abgehoben....");
        System.out.println("Kontostand nach Abheben: "+konto.kontostand);
        System.exit(0);
    }
}
